import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import javax.microedition.rms.*;
import java.util.*;
import javax.microedition.io.*;
import java.io.*;

//import org.kxml.*;
import org.kxml.kdom.*;
import org.kxml.io.*;
import org.kxml.parser.*;


public class example extends MIDlet implements CommandListener {
	
	String errorMessage = null;
	userData user = new userData();
	int dbIndex=0;
	Hashtable allUser = new Hashtable();
	
	RmsDB db = new RmsDB("userDataBase");
	
	/* frame */	
	private Display d = Display.getDisplay(this);
	
	/* main menu */
	private Form form = new Form("Add User");
	
	/* common list */
	private List userList;

	/* textarea */
	private TextBox userDetail = new TextBox("User Detail","",500,TextField.ANY);

	/* main menu */
	private Form modifyUser = new Form("Modify User Data");	

	/* record the current showing menu */
	private String currentMenu = null;
	
    /*command */
    private final Command CmdOk 		= new Command("Ok", Command.OK,1);
    private final Command CmdExit 	= new Command("Exit", Command.SCREEN,1);
    private final Command CmdCancel 	= new Command("Cancel", Command.CANCEL,1);
    

    private final Command CmdImportData= new Command("ImportData", Command.SCREEN,1);
    private final Command CmdRefresh	= new Command("Refresh", Command.SCREEN,1);
    
    private final Command CmdAdd 		= new Command("Add Record", Command.SCREEN,1);
    private final Command CmdDelete	= new Command("Delete Record", Command.SCREEN,1);
    private final Command CmdModify 	= new Command("Modify Record", Command.SCREEN,1);
    private final Command CmdDetail 	= new Command("Show Detail", Command.SCREEN,1);


	private TextField  formName 		= new TextField("Name", "", 13,TextField.ANY);
	private TextField  formAddress		= new TextField("Address", "", 13,(TextField.ANY));
	private TextField  formPhone 		= new TextField("Phone", "", 53,(TextField.ANY));
	private TextField  formSex 		= new TextField("Sex", "",1,(TextField.ANY));
	private DateField  formBirthday	= new DateField("Birthday",DateField.DATE);
	
	protected void startApp() throws MIDletStateChangeException {
		form.addCommand(CmdOk);
		form.addCommand(CmdCancel);
		form.append(formName);
		form.append(formAddress);
		form.append(formPhone);
		form.append(formSex);
		form.append(formBirthday);
		form.setCommandListener(this);
		
		userList();

		formBirthday.setDate(user.birthday);
	}

	protected void pauseApp() {
	}

	protected void destroyApp(boolean flag) throws MIDletStateChangeException {
	}

	public void commandAction(Command c, Displayable s) {

        String cLabel = c.getLabel();
        
		if (currentMenu.equals("userList")) {

			int index= userList.getSelectedIndex();
			dbIndex = index + 1;
			if ( c == CmdAdd) { 
				addUser();
			} else if ( c == CmdDelete) {
				if ( userList.isSelected(index) ) {
					deleteUserData();
					userList();
				}
			} else if ( c == CmdModify) {
				if ( userList.isSelected(index) )
					modifyUser();
			} else if ( c == CmdRefresh) {
					userList();
			} else if ( c == CmdImportData) {
				dataImport();
				Alert noticeAlert = 
   					new Alert("Import Data","Success",null, null);
		   		d.setCurrent(noticeAlert);
			} else if ( c == CmdExit) {
				this.notifyDestroyed();
			} else { //( c == CmdOk || c == CmdDetail) { //show detail
				if ( userList.isSelected(index) ) {
					XML2Struc( db.getRecordString(index+1) );
					showDetail();
				}
			}
			
		} else if (currentMenu.equals("addUser")) {
			if ( c == CmdOk) {
				Date date = formBirthday.getDate();
				
				user.name 		= formName.getString();
				user.address 	= formAddress.getString();
				user.phone 		= formPhone.getString();
				user.sex 		= formSex.getString();
				user.birthday.setTime(date.getTime());
				insertUserData();
				userList();
			} else if ( c == CmdCancel) {
				userList();
			}
			
		} else if (currentMenu.equals("modifyUser")) {
			if ( c == CmdOk) {
				user.name 		= formName.getString();
				user.address 	= formAddress.getString();
				user.phone 		= formPhone.getString();
				user.sex 		= formSex.getString();
				user.birthday = formBirthday.getDate();

				modifyUserData();
				userList();
			} else if ( c == CmdCancel) {
				userList();
			} else if ( c == CmdDetail) {
				showDetail();
			}

		} else if (currentMenu.equals("showDetail")) {
			if ( c == CmdOk) {
				userList();
			} else if ( c == CmdAdd) {
				addUser();
			} else if ( c == CmdDelete) {
				deleteUserData();
				userList();
			} else if ( c == CmdModify) {
				modifyUser();
			} else if ( c == CmdExit) {
				this.notifyDestroyed();
			}			
		}
	}

	private void alertFunc(String title, String message, Displayable nextDisplay) {
		Alert noticeAlert = 
   			new Alert(title, message ,null, null);
   		if ( nextDisplay == null )
	   		d.setCurrent(noticeAlert);
	   	else 
	   		d.setCurrent(noticeAlert,nextDisplay);
	}

	private void addUser() {
		formName.setString("");
		formAddress.setString("");
		formPhone.setString("");
		formSex.setString("");

		form.setTitle("Add User");
		form.setCommandListener(this);

		d.setCurrent(form);
		currentMenu="addUser";
	}

	private void modifyUser() {
		formName.setString(user.name);
		formAddress.setString(user.address);
		formPhone.setString(user.phone);
		formSex.setString(user.sex);
		formBirthday.setDate(user.birthday);
		
		form.setTitle("Modify");
		form.setCommandListener(this);
		
		d.setCurrent(form);
		currentMenu="modifyUser";
	}
	
	private void showDetail() {
		String temp = "User Name: " + user.name + "\n";
		temp += "Phone Number: " + user.phone + "\n";
		temp += "Address: " + user.address + "\n";
		temp += "Sex: " + user.sex + "\n";
		temp += "Birthday: " + Long.toString(user.birthday.getTime());
		
		userDetail.setString(temp);
		userDetail.addCommand(CmdOk);
		userDetail.addCommand(CmdAdd);
		userDetail.addCommand(CmdModify);
		userDetail.addCommand(CmdDelete);
		userDetail.addCommand(CmdExit);
		userDetail.setCommandListener(this);
		d.setCurrent(userDetail);
		currentMenu="showDetail";
	}

	private void userList() {
		String tempData=null;
		userList = new List("User List",List.IMPLICIT);

		for(int i=1; i<= db.recordCount() ; i++) {
			XML2Struc( db.getRecordString(i) );
			userList.append(user.name,null);
		}
		userList.addCommand(CmdOk);
		userList.addCommand(CmdAdd);
		userList.addCommand(CmdDetail);
		userList.addCommand(CmdModify);
		userList.addCommand(CmdDelete);
		userList.addCommand(CmdRefresh);
		userList.addCommand(CmdImportData);
		userList.addCommand(CmdExit);
		
		userList.setCommandListener(this);
		d.setCurrent(userList);
		currentMenu="userList";
	}
	
	public void XML2Struc(String xml) {
		try {
			ByteArrayInputStream bin = new ByteArrayInputStream( xml.getBytes() );
			XmlParser parser = new XmlParser( new InputStreamReader( bin ) );
			Document doc = new Document();
			doc.parse(parser);
			Element element = doc.getRootElement();
			user.name	 	= element.getAttribute("name").getValue();
			user.address 	= element.getElement("address").getText();
			user.phone		= element.getElement("phone").getText();
			user.sex		= element.getElement("sex").getText();
			user.birthday.setTime(Long.parseLong(element.getElement("birthday").getText()));

		} catch( IOException e ) {
			errorMessage = e.toString();
		}
	}

	/* <user name="" >
	 *		<birthday></birthday>
	 * 		<address></address>
	 * 		<phone></phone>
	 * 		<sex></sex>
	 * </user>
	 */
	public void insertUserData() {
		String xml="";
		xml = "<user name=\"" + user.name + "\">";
		xml = xml + "<birthday>" + Long.toString(user.birthday.getTime()) + "</birthday>";
		xml = xml + "<address>" + user.address + "</address>";
		xml = xml + "<phone>" + user.phone + "</phone>";
		xml = xml + "<sex>" + user.sex + "</sex>";
		xml = xml + "</user> ";

		db.addRecord(xml);
	}
	
	public void modifyUserData() {
		String xml="";
		xml = "<user name=\"" + user.name + "\">";
		xml = xml + "<birthday>" + Long.toString(user.birthday.getTime()) + "</birthday>";
		xml = xml + "<address>" + user.address + "</address>";
		xml = xml + "<phone>" + user.phone + "</phone>";
		xml = xml + "<sex>" + user.sex + "</sex>";
		xml = xml + "</user> ";
		db.updateRecord(xml,dbIndex);
	}
	
	public void deleteUserData() {
		db.delRecord(dbIndex);
	}

	public void dataImport() {
		user.name="skin";
		user.address="DormC";
		user.sex="M";
		user.phone="4754";
		user.birthday.setTime(333333333);
		insertUserData();
		
		user.name="hwang";
		user.address="MIS";
		user.sex="M";
		user.phone="4732";
		user.birthday.setTime(222222222);
		insertUserData();
	}

	public class userData {
		String name 	= new String();
		Date birthday 	= new Date();
		String phone 	= new String();
		String address 	= new String();
		String sex		= new String();
	}
}

